$main-card: (
    'height': 740px,
    'width': 350px
);

$second-card: (
    'height': 500px,
    'width': 240px,
    'offset': 115px
);

$third-card: (
    'height': 350px,
    'width': 120px,
    'offset': 230px
);

$fourth-card: (
    'height': 260px,
    'width': 90px,
    'offset': 340px
);

$cover-card-gradient: (
    'from': #1b1c25,
    '29': #282937,
    'to': #505166
);

$transition-time: 300ms;

@mixin card-factory($index) {
    $main-card-width: map-get($main-card, 'width');

    transition: all $transition-time ease;
    transition-property: height, width, left, top, transform, z-index, filter;

    &::before {
        content: '';
        width: 100%;
        height: 220px;
        background: linear-gradient(0deg, rgba(0, 0, 0, 0) 0, rgba(0, 0, 0, 0.6) 100%);
        position: absolute;
        bottom: 0;
        right: 0;

        filter: blur(4px);

        transition: all $transition-time ease;
    }

    &::after {
        content:'';
        position:absolute;
        left:0; top:0;
        width:100%; height:100%;
        display:inline-block;
        background-image: linear-gradient(90deg, #1b1c25cc 0%,#505166cc 100%);

        opacity: 1;

        transition: opacity $transition-time ease;
    }

    @if $index <= 0 or $index >= 8 {
        height: 0;
        width: 0;

        $multiply-coef: if($index >= 8, 1, -1);

        top: calc(50%);
        @if $index <= 0 { 
            left: calc(50% - (#{$main-card-width} / 2) - 430px);

            transform: perspective(100px)  rotateY(-1deg);
        } @else {    
            left: calc(50% + (#{$main-card-width} / 2) + 430px);
    
            transform: perspective(100px) rotateY(0);
        }

        filter: blur(7px);
        
        z-index: 1;
        

        &::before {
            height: 0;
            transform: perspective(50px) rotateX(1deg) rotateY(0) translate($multiply-coef * 0px, 0px) skewX($multiply-coef * 45deg);
        }
    } @else {
        @if $index == 1 or $index == 7 { 
            $height: map-get($fourth-card, $key: 'height');
            $width: map-get($fourth-card, $key: 'width');
            $offset: map-get($fourth-card, $key: 'offset');

            $multiply-coef: if($index == 7, 1, -1);

            height: $height;
            width: $width;

            top: calc(50% - #{$height / 2});
    
            @if($index == 1) {         
                left: calc(50% - (#{$main-card-width} / 2) - #{$offset + 20px});
        
                transform: perspective(12px) rotateY(-1deg);
            }
            @else {
                left: calc(50% + (#{$main-card-width} / 2) + #{$offset - $width + 30px});
        
                transform: perspective(12px) rotateY(1deg);
            }

            filter: blur(5px);

            z-index: 2;

            &::before {
                height: 155px;
                transform: perspective(50px) rotateX(1deg) rotateY(0) translate($multiply-coef * 93px, 167px) skewX($multiply-coef * 52deg);
            }
        }

        @if $index == 2 or $index == 6 {  
            $height: map-get($third-card, $key: 'height');
            $width: map-get($third-card, $key: 'width');
            $offset: map-get($third-card, $key: 'offset');

            height: $height;
            width: $width;

            $multiply-coef: if($index == 6, 1, -1);

            top: calc(50% - #{$height / 2});

            @if($index == 2) {         
                left: calc(50% - (#{$main-card-width} / 2) - #{$offset + 20px});

                transform: perspective(15px)  rotateY(-1deg);
            }
            @else {
                left: calc(50% + (#{$main-card-width} / 2) + #{$offset - $width + 30px});
        
                transform: perspective(15px) rotateY(1deg);
            }

            filter: blur(4px);
                
            z-index: 3;

            &::before {
                content: '';
                transform: perspective(220px) rotateX(1deg) rotateY(0) translate($multiply-coef * 116px, 249px) skewX($multiply-coef * 45deg);
            }
        }

        @if $index == 3 or $index == 5 {   
            $height: map-get($second-card, $key: 'height');
            $width: map-get($second-card, $key: 'width');
            $offset: map-get($second-card, $key: 'offset');

            height: $height;
            width: $width;

            $multiply-coef: if($index == 5, 1, -1);

            top: calc(50% - #{$height / 2});

            @if($index == 3) {
                left: calc(50% - (#{$main-card-width} / 2) - #{$offset});
            }
            @else {
                left: calc(50% + (#{$main-card-width} / 2) - #{$offset});
            }
            
            transform: perspective(25px) rotateY(#{-4 + $index + deg});

            filter: blur(3px);
            
            z-index: 4;

            &::before {
                content: '';
                height: 154px;
                width: 60%;

                @if($index == 3) {
                    transform: perspective(13px) rotateX(1deg) rotateY(0) translate(calc(-94px - 40%), 162px) skewX(-45deg);
                }
                @else {
                    transform: perspective(13px) rotateX(1deg) rotateY(0) translate(94px, 162px) skewX(45deg);
                }
            }
        }

        @if $index == 4 {
            $height: map-get($map: $main-card, $key: 'height');

            height: $height;
            width: $main-card-width;


            top: calc(50% - #{$height / 2});
            left: calc(50% - (#{$main-card-width} / 2));
    
            transform: perspective(0)  rotateY(0);

            z-index: 5;
            filter: blur(0);

            &::before {
                width: 250px;
                transform: perspective(6px) rotateX(1deg) translate(-30px, 210px) skewX(0deg);
            }

            &::after {
                opacity: 0;
            }
        }

    }
}

.card {

    position: absolute;


    background-size: 100% 100%;
    background-image: url(https://i.pinimg.com/originals/83/f9/37/83f937b69f30bb886ab8a03390da6771.jpg);

    &[attr-type=left-outer] { @include card-factory(0); }
    &[attr-type=left-fourth] { @include card-factory(1); }
    &[attr-type=left-third] { @include card-factory(2); }
    &[attr-type=left-second] { @include card-factory(3); }
    &[attr-type=main] { @include card-factory(4); }
    &[attr-type=right-second] { @include card-factory(5); }
    &[attr-type=right-third] { @include card-factory(6); }
    &[attr-type=right-fourth] { @include card-factory(7); }
    &[attr-type=right-outer] { @include card-factory(8); }
}
